

#include "Registers_input_output.h"
#include "built_in.h"

// LCD module connections
sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;

sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;
// End LCD module connections */

unsigned char kp=0, key=0;

void Set_up() {

  ANSEL = 0;
  ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
  C1ON_bit = 0;    // analog comparators off.
  C2ON_bit = 0;
  TRISB = 0x80;
  PORTB = 0;
  Lcd_Init();                        // Initialize LCD
  Lcd_Cmd(_LCD_CLEAR);               // Clear display
  Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
}

void main() {
Set_up();
Lcd_Out(1,7,"KEY:");
while (1)   {
kp=Read_Register();
Write_Register(key);
switch (kp){
  case  17:  Lcd_Chr(2,8,'7'); key=17; delay_ms(100); break;
  case  18:  Lcd_Chr(2,8,'4'); key=18; delay_ms(100); break;
  case  20:  Lcd_Chr(2,8,'1'); key=20; delay_ms(100); break;
  case  24:  Lcd_Chr(2,8,'#'); key=24; delay_ms(100); break;
  case  33:  Lcd_Chr(2,8,'8'); key=33; delay_ms(100); break;
  case  34:  Lcd_Chr(2,8,'5'); key=34; delay_ms(100); break;
  case  36:  Lcd_Chr(2,8,'2'); key=36; delay_ms(100); break;
  case  40:  Lcd_Chr(2,8,'0'); key=40; delay_ms(100); break;
  case  65:  Lcd_Chr(2,8,'9'); key=65; delay_ms(100); break;
  case  66:  Lcd_Chr(2,8,'6'); key=66; delay_ms(100); break;
  case  68:  Lcd_Chr(2,8,'3'); key=68; delay_ms(100); break;
  case  72:  Lcd_Chr(2,8,'*'); key=72; delay_ms(100);  break;
  case  129:  Lcd_Chr(2,8,'A'); key=129; delay_ms(100); break;
  case  130:  Lcd_Chr(2,8,'B'); key=130; delay_ms(100); break;
  case  132:  Lcd_Chr(2,8,'C'); key=132; delay_ms(100); break;
  case  136:  Lcd_Chr(2,8,'D'); key=136; delay_ms(100); break;
 }

}   

  }